# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""

#Marcin Śliwa
import os
import Mapa_PU
import  time, datetime
from PyQt5 import QtWidgets, uic
from PyQt5.QtWidgets import QFileDialog
from PyQt5.QtGui import * 
from PyQt5.QtCore import * 
from Mapa_PU.kontroler import metody_globalne
from Mapa_PU.kontroler import komunikaty
from Mapa_PU.model import konfiguracja
from Mapa_PU.model.baza_danych import Baza
from operator import itemgetter 

FORM_CLASS, _ = uic.loadUiType(os.path.join(os.path.dirname(__file__), 'eksportuj_swdl_dialog.ui'))

class EksportujSWDLDialog(QtWidgets.QDialog,FORM_CLASS):
    """Widok eksportu danych do pliku SWDL"""
    def __init__(self,konfiguracja,rodzic=None):
        super(EksportujSWDLDialog,self).__init__(rodzic)
        self.__rodzic=rodzic
        self.__konfiguracja=konfiguracja
        self.setupUi(self)
        #self.setWindowFlags( Qt.Dialog | Qt.WindowTitleHint )
        self.setWindowFlags( Qt.Dialog)
        self.setWindowIcon(QIcon('%s\\ikony\\Logo_BULiGL.ico' % Mapa_PU.upul_modul.root))
        
        #QObject.connect(self.btSciezka, SIGNAL("clicked()"), self.ustawPlik)
        self.btSciezka.clicked.connect(self.ustawPlik)
        
        reg_email = QRegExp("[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}")
        email_validator = QRegExpValidator(reg_email, self.txtEmail)
        self.txtEmail.setValidator(email_validator)
       
        
        regKod=QRegExp("[0-9]{2}-[0-9]{3}")
        kodValidator=QRegExpValidator(regKod,self.txtKod)
        self.txtKod.setValidator(kodValidator)
        regTelefon=QRegExp("[1-9]{1}[0-9]{8}")
        telefonValidator=QRegExpValidator(regTelefon,self.txtTelefon)
        self.txtTelefon.setValidator(telefonValidator)
        
       
        
        #QObject.connect(self.rbDataDomyslna, SIGNAL("toggled(bool)"), self.kontroluj)
        self.rbDataDomyslna.toggled.connect(self.kontroluj)
        
        #QObject.connect(self.rbInnaData, SIGNAL("toggled(bool)"), self.kontroluj)
        self.rbInnaData.toggled.connect(self.kontroluj)
        
        #QObject.connect(self.txtNazwa, SIGNAL("textChanged (QString)"), self.kontroluj)
        self.txtNazwa.textChanged.connect(self.kontroluj)
        
        #QObject.connect(self.txtUlica, SIGNAL("textChanged (QString)"), self.kontroluj)
        self.txtUlica.textChanged.connect(self.kontroluj)
        
        #QObject.connect(self.txtKod, SIGNAL("textChanged (QString)"), self.kontroluj)
        self.txtKod.textChanged.connect(self.kontroluj)
        
        #QObject.connect(self.txtMiasto, SIGNAL("textChanged (QString)"), self.kontroluj)
        self.txtMiasto.textChanged.connect(self.kontroluj)
        
        #QObject.connect(self.txtStanowisko, SIGNAL("textChanged (QString)"), self.kontroluj)
        self.txtStanowisko.textChanged.connect(self.kontroluj)
        
        #QObject.connect(self.cbWoj,SIGNAL("textChanged (QString)"),self.aktualizuj_woj)
        self.cbWoj.editTextChanged.connect(self.aktualizuj_woj)
        
        #QObject.connect(self.cbPow,SIGNAL("textChanged (QString)"),self.aktualizuj_pow)
        self.cbPow.editTextChanged.connect(self.aktualizuj_pow)
        
        #QObject.connect(self.cbGmina,SIGNAL("textChanged (QString)"),self.aktualizuj_gmina)
        self.cbGmina.editTextChanged.connect(self.aktualizuj_gmina)
        
        #QObject.connect(self.cbObreb,SIGNAL("textChanged (QString)"),self.aktualizuj_obreb)
        self.cbObreb.editTextChanged.connect(self.aktualizuj_obreb)
        
        #QObject.connect(self.cbWlasnosc, SIGNAL("textChanged (QString)"), self.aktualizuj_wlasnosc)
        self.cbWlasnosc.editTextChanged.connect(self.aktualizuj_wlasnosc)
       
        #QObject.connect(self.cbOddzial,SIGNAL("textChanged (QString)"),self.aktualizuj_oddzial)
        self.cbOddzial.editTextChanged.connect(self.aktualizuj_oddzial)
        
        self.generuj.setEnabled(False)
        
        dzis=datetime.date.today()
        self.deData.setDate(QDate(dzis.timetuple()[0],1,1))
        self.__dane=self.pobierz_adresy_lesne()
        lista=self.czesc_adresu(0,1)
        self.cbWoj.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbWoj))
        self.cbWoj.addItems(lista)
        
        
        
    def aktualizuj_woj(self):
        """aktualizuje wartosci powiatu na podstawie wojewodztwa
        
        """
        try:
            self.cbPow.clear()
            if self.woj=='':
                return
            lista=self.czesc_adresu(1,3,self.woj)
            
            self.cbPow.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbPow))
            self.cbPow.addItems(lista)
          
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def aktualizuj_pow(self):
        """aktualizuje wartosci gminy na podstawie woj i powiatu
        
        """
        try:
            self.cbGmina.clear()
            if self.pow=='':
                return
            adres='%s%s' % (self.woj,self.pow)
            lista=self.czesc_adresu(3,6,adres)
            
            self.cbGmina.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbGmina))
            self.cbGmina.addItems(lista)
           
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def aktualizuj_gmina(self):
        """aktualizuje wartosci obrebu na podstawie woj i powiatu i gminy
        
        """
        try:
            self.cbObreb.clear()
            if self.gmina=='':
                return
            adres='%s%s%s' % (self.woj,self.pow,self.gmina)
            lista=self.czesc_adresu(6,10,adres)
            
            self.cbObreb.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbObreb))
            self.cbObreb.addItems(lista)
         
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def aktualizuj_obreb(self):
        """aktualizuje wartosci wlasnosci na podstawie woj i powiatu i gminy i obrebu
        
        """
        try:
            self.cbWlasnosc.clear()
            if self.obreb=='':
                return
            adres='%s%s%s%s' % (self.woj,self.pow,self.gmina,self.obreb)
            lista=self.czesc_adresu(11,13,adres)
            
            self.cbWlasnosc.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbWlasnosc))
            self.cbWlasnosc.addItems(lista)
          
        except Exception as e:
            komunikaty.blad_systemowy(e)
    
    def aktualizuj_wlasnosc(self):
        """aktualizuje wartosci oddzialu na podstawie woj i powiatu i gminy i obrebu i formy wlasnosci
        
        """
        try:
            self.cbOddzial.clear()
            if self.wlasnosc=='':
                return
            adres='%s%s%s%s-%s' % (self.woj,self.pow,self.gmina,self.obreb,self.wlasnosc)
            lista=self.czesc_adresu(13,17,adres)
            
            self.cbOddzial.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbOddzial))
            self.cbOddzial.addItems(lista)
         
        except Exception as e:
            komunikaty.blad_systemowy(e)
        
    def aktualizuj_oddzial(self):
        """aktualizuje wartosci pododdzialu na podstawie woj i powiatu i gminy i obrebu i formy wlasnosci i oddzialu
        
        """
        try:
            self.cbPoddz.clear()
            if self.oddzial=='':
                return
            adres='%s%s%s%s-%s%s' % (self.woj,self.pow,self.gmina,self.obreb,self.wlasnosc,self.oddzial)
            lista=self.czesc_adresu(18,22,adres)
            
            self.cbPoddz.setValidator(QRegExpValidator(QRegExp("(%s)" % '|'.join(lista)),self.cbPoddz))
            self.cbPoddz.addItems(lista)
         
        except Exception as e:
            komunikaty.blad_systemowy(e)
        
    
    def kontrolujAdresLesny(self):
        """kontrola adresu lesnego"""
     
        if self.adresLesny=='':
            return False
        else:
            return True
    
    def kontrolujSciezkePliku(self):
        """kontrola pliku scieżki pliku swdl"""
        if self.plik=='':
            return False
        else:
            return True
        
    def kontrolujAdres(self):
        """Kontrola adresu"""
      
        return self.txtNazwa.text()!='' and self.txtUlica.text()!='' and self.txtKod.text()!='' and self.txtMiasto.text()!=''
    
    def kontrolujDate(self):
        """kontrola wyboru daty"""
      
        return self.rbInnaData.isChecked() or self.rbDataDomyslna.isChecked()
    
    def kontrolujOsobe(self):
        """kontrola stanowiska osoby odpowiedzialnej za plik"""
     
        if self.stanowisko=='':
            return False
        else:
            return True
    
    def kontroluj(self):
        """Kontrola danych"""
        self.generuj.setEnabled(self.kontrolujAdresLesny() and self.kontrolujDate() and self.kontrolujAdres() and self.kontrolujOsobe() and self.kontrolujSciezkePliku())
    
    
    def closeEvent(self, *args, **kwargs):
        pass
     
    def accept(self):
        """Akceptacja kontroli"""
        
        self.setResult(1)
        self.close()
        
    def reject(self):
        """Anulowanie kontroli"""
        self.setResult(0)
        self.close()
    
    def ustawPlik(self):
        """Ustawia plik SWDL"""
        #ret=QFileDialog.getSaveFileName(self.__rodzic,u'Proszę podać nazwę pliku SWDL',self.__konfiguracja.sciezka,"Plik SWDL (*.swdl *.SWDL)")
        ret=QFileDialog.getSaveFileName(self.__rodzic,u'Proszę podać nazwę pliku SWDL',self.__konfiguracja.sciezka,"Plik SWDL (*.zip *.ZIP)")
        if ret=='':
           self.plik=''
        else:
           self.plik=os.path.normpath(ret[0])
        
        self.kontroluj()
    
    @property
    def nazwaOsoby(self):
        """Nazwa Osoby Odpowiedzialnej"""
        return self.txtNazwaOsobyOdpowiedzialnej
    @nazwaOsoby.getter
    def nazwaOsoby(self):
        return self.txtNazwaOsobyOdpowiedzialnej.text()
    
    
    @property
    def dataDomyslna(self):
        """Pierwszy stycznia obowiazywania planu"""
        return self.rbDataDomyslna
    @dataDomyslna.getter
    def dataDomyslna(self):
        return self.rbDataDomyslna.isChecked()
        
    
    @property
    def wykonawca(self):
        """Nazwa wykonawcy"""
        return self.txtWykonawca
    @wykonawca.getter
    def wykonawca(self):
        return self.txtWykonawca.text()
    
    @property
    def poddz(self):
        """pododdział"""
        return self.cbPoddz
    @poddz.getter
    def poddz(self):
        return self.cbPoddz.currentText()
    
    @property
    def oddzial(self):
        """Oddział"""
        return self.cbOddzial
    @oddzial.getter
    def oddzial(self):
        return self.cbOddzial.currentText()
    
    @property
    def wlasnosc(self):
        """forma własności"""
        return self.cbWlasnosc
    @wlasnosc.getter
    def wlasnosc(self):
        return self.cbWlasnosc.currentText()
    
    @property
    def obreb(self):
        """obreb"""
        return self.cbObreb
    @obreb.getter
    def obreb(self):
        return self.cbObreb.currentText()
    
    @property
    def gmina(self):
        """gmina"""
        return self.cbGmina
    @gmina.getter
    def gmina(self):
        return self.cbGmina.currentText()
    
    @property
    def pow(self):
        """powiat"""
        return self.cbPow
    @pow.getter
    def pow(self):
        return self.cbPow.currentText()
    
    @property
    def woj(self):
        """Wojwództwo"""
        return self.cbWoj
    @woj.getter
    def woj(self):
        return self.cbWoj.currentText()
    
    @property
    def nazwa(self):
        """Nazwa instytucji"""
        return self.txtNazwa
    
    @nazwa.getter
    def nazwa(self):
        return self.txtNazwa.text()
    
    @property
    def plik(self):
        """Scieżka do pliku SWDL"""
        return self.txtSciezkaSWDL
    
    @plik.setter
    def plik(self,wartosc):
        self.txtSciezkaSWDL.setText(wartosc)
    
    @plik.getter
    def plik(self):
        return self.txtSciezkaSWDL.text()
          
    @property
    def email(self):
        """Adres poczty elektronicznej osoby przygotowywującej SWDL"""
        return self.txtEmail
    
    @email.getter
    def email(self):
        return self.txtEmail.text()
    
    @property
    def telefon(self):
        """Telefon osoby przygotowywujacej SWDL"""
        return self.txtTelefon
    
    @telefon.getter
    def telefon(self):
        return self.txtTelefon.text()
    
    @property
    def stanowisko(self):
        """Stanowisko osoby przygotowującej plik SWDL"""
        return self.txtStanowisko
    
    @stanowisko.getter
    def stanowisko(self):
        return self.txtStanowisko.text()
    
    @property
    def adres(self):
        """Adres podmiotu generującego plik SWDL"""
        pass
     
    @adres.getter
    def adres(self):
        return '-'.join((self.txtUlica.text(),self.txtKod.text(),self.txtMiasto.text()))
    
  
    
    @property
    def data(self):
        """Data stanu danych"""
        return self.deData
    
    @data.getter
    def data(self):
        return self.deData.date()
        
    
    @property
    def adresLesny(self):
        """Adres leśny"""
        pass 
    
    @adresLesny.getter
    def adresLesny(self):
        lista=('%s%s%s%s' % (self.woj,self.pow,self.gmina,self.obreb),'%s%s' % (self.wlasnosc,self.oddzial),self.poddz)
        adres='-'.join([i  for i in lista if i.strip()!= ''])
        return adres
    
    @property
    def rokUrzadzania(self):
        """Rok urządzania"""
        return self.txtRokUrzadzania
    
    @rokUrzadzania.getter
    def rokUrzadzania(self):
        return self.txtRokUrzadzania.text()
    
    def pobierz_adresy_lesne(self):
        """Zwraca tabelę listę wydzieleń
        :return dane
        """
        try:
         
            sql="SELECT DISTINCT F_ARODES.ADRESS_FOREST, F_ARODES.ORDER_KEY, F_ARODES.ARODES_TYP_CD FROM F_ARODES WHERE (((F_ARODES.ARODES_TYP_CD)='WYDZIEL') AND ((F_ARODES.ADRESS_VALID)='T'));"
            baza=Baza(self.__konfiguracja.plikBazaTaksator)
            baza.polaczOdbc()
            dane=baza.wykonajZapytanie(sql)
            return dane
            
        except Exception as e:
            komunikaty.blad_systemowy(e)
        finally:
            baza.zamknijPolaczenie()
    
    def czesc_adresu(self,p=0,k=0,wzorzec=None):
        """Zwraca częśc adresu lesnego
        :param lista; lista wydzieleń
        :param p:indeks poczatku adresu
        :param k:indeks konca adresu
        :return lista części adresów
        """
        try:
            if wzorzec==None:
                l=[x[0][p:k].strip() for x in sorted(self.__dane,key=itemgetter(1))]
            else:
                lista=[x for x in self.__dane if (x[0].strip())[0:len(wzorzec.strip())]==wzorzec.strip()]
                l=[x[0][p:k].strip() for x in lista]#sorted(lista,key=itemgetter(1))]
            #dodanie pustego wyboru
            if ('' in l)==False:
                l.insert(0,'')
            return sorted(set(l))

        except Exception as e:
            komunikaty.blad_systemowy(e)
        
    
#     def czesc_adresu(self,p=0,k=0,wzorzec=None,typ=u'OBRĘB'):
#         """Zwraca częc adresu lesnego
#         :param p:indeks poczatku adresu
#         :param k:indeks konca adresu
#         :param wzorzec: wzorzec do porównania
#         :return lista części adresów
#         """
#         try:
#            
#             if wzorzec==None:
#                 lista=[x for x in self.__dane if x[2]=='%s' % typ]
#                 l=[(x[0])[0].strip() for x in sorted(lista,key=itemgetter(1))]
#             else:
#                 lista=[x for x in self.__dane if (x[0])[0:len(wzorzec)]==wzorzec and x[2]=='%s' % typ]
#                 l=[]
#                 for x in sorted(lista,key=itemgetter(1)):
#                     wartosc=(x[0])[p:k].strip()
#                     if (wartosc in l)==False:
#                         l.append(wartosc)
#            
#             
#             #dodanie pustego wyboru
#             if ('' in l)==False:
#                 l.insert(0,'')
#             return l
#         except Exception as e:
#             komunikaty.blad_systemowy(e)